<template>
  <div>
    <form @submit.prevent="onSubmit">
        <div class="form-group">
          <label for="">{{task.tle}}</label>
          <input 
            type="text" 
            class="form-control"
            placeholder="Add new task..."
            v-model="task.title"
            required
            maxlength="50">
        </div>
        <div class="form-group">
          <label for="">Description</label>
          <textarea type="text" class="form-control-textarea" rows="4"
          v-model="task.description"></textarea>
        </div>
        <div class="form-inline">
            <div class="form-group cus-form">
                <label for="">Due Date</label>
                <VueDatePicker v-model="task.dueDate" format="YYYY-MM-DD" class="form-control" :minDate="minDate"/>
            </div>
            <div class="form-group cus-form">
                <label for="">Priority</label><br>
                <select name="priority" class="form-control"
                  v-model="task.priority">
                    <option value="low">Low</option>
                    <option value="normal">Normal</option>
                    <option value="high">High</option>
                </select>
            </div>
        </div>
        <div class="form-group">
            <button class="btn btn-success btn-full">
                {{ editTask ? 'Update' : 'Add'}}
            </button>
        </div>   
      </form> 
  </div>
</template>
<script lang="ts">
import { 
  Component,
  Vue,
  Prop,
  Emit,
 } from 'vue-property-decorator';
import { VueDatePicker, } from '@mathieustan/vue-datepicker';
import '@mathieustan/vue-datepicker/dist/vue-datepicker.min.css';

import { Task } from '@/models/task';
@Component({
  components:{
    VueDatePicker,
  }
})
export default class TaskForm extends Vue{
  @Prop() editTask?: Task | null;
  public task: Task = new Task(0, "", "", this.getToday(), 'normal');
  public minDate: Date = this.getMinDate();

  created(){
    if(this.editTask){
      this.task = this.editTask;
    }
  }
  onSubmit(){
    if(this.task.title !== '' && this.task.dueDate !== null){
      this.$emit('submit', this.task);
    }

    if(!this.editTask){
      this.task = new Task(0, "", "", this.getToday(), 'normal');
    }
  }

  getToday(){
    const today = new Date();
    const year = today.getFullYear();
    const month = ""+ (today.getMonth() + 1);
    const day = "" +today.getDate();
    return `${year}-${month.padStart(2,"0")}-${day.padStart(2, "0")}`;
  }
  getMinDate(): Date{
    const today = new Date();
    today.setDate(today.getDate() - 1);
    return today;
  }
}
</script>
<style scoped>
.vd-wrapper{
  border: 1px solid black;
  padding-left: 5px;
}
</style>